## GtkTreeModel GtkTreeModel — The tree interface used by GtkTreeView |

## Functions

gboolean | (*GtkTreeModelForeachFunc) ()
GtkTreePath * | gtk_tree_path_new ()
GtkTreePath * | gtk_tree_path_new_from_string ()
GtkTreePath * | gtk_tree_path_new_from_indices ()
gchar * | gtk_tree_path_to_string ()
GtkTreePath * | gtk_tree_path_new_first ()
#define | gtk_tree_path_new_root
void | gtk_tree_path_append_index ()
void | gtk_tree_path_prepend_index ()
gint | gtk_tree_path_get_depth ()
gint * | gtk_tree_path_get_indices ()
gint * | gtk_tree_path_get_indices_with_depth ()
void | gtk_tree_path_free ()
GtkTreePath * | gtk_tree_path_copy ()
gint | gtk_tree_path_compare ()
void | gtk_tree_path_next ()
gboolean | gtk_tree_path_prev ()
gboolean | gtk_tree_path_up ()
void | gtk_tree_path_down ()
gboolean | gtk_tree_path_is_ancestor ()
gboolean | gtk_tree_path_is_descendant ()
GtkTreeRowReference * | gtk_tree_row_reference_new ()
GtkTreeRowReference * | gtk_tree_row_reference_new_proxy ()
GtkTreeModel * | gtk_tree_row_reference_get_model ()
GtkTreePath * | gtk_tree_row_reference_get_path ()
gboolean | gtk_tree_row_reference_valid ()
void | gtk_tree_row_reference_free ()
GtkTreeRowReference * | gtk_tree_row_reference_copy ()
void | gtk_tree_row_reference_inserted ()
void | gtk_tree_row_reference_deleted ()
void | gtk_tree_row_reference_reordered ()
GtkTreeIter * | gtk_tree_iter_copy ()
void | gtk_tree_iter_free ()
GtkTreeModelFlags | gtk_tree_model_get_flags ()
gint | gtk_tree_model_get_n_columns ()
GType | gtk_tree_model_get_column_type ()
gboolean | gtk_tree_model_get_iter ()
gboolean | gtk_tree_model_get_iter_from_string ()
gboolean | gtk_tree_model_get_iter_first ()
#define | gtk_tree_model_get_iter_root()
GtkTreePath * | gtk_tree_model_get_path ()
void | gtk_tree_model_get_value ()
gboolean | gtk_tree_model_iter_next ()
gboolean | gtk_tree_model_iter_children ()
gboolean | gtk_tree_model_iter_has_child ()
gint | gtk_tree_model_iter_n_children ()
gboolean | gtk_tree_model_iter_nth_child ()
gboolean | gtk_tree_model_iter_parent ()
gchar * | gtk_tree_model_get_string_from_iter ()
void | gtk_tree_model_ref_node ()
void | gtk_tree_model_unref_node ()
void | gtk_tree_model_get ()
void | gtk_tree_model_get_valist ()
void | gtk_tree_model_foreach ()
void | gtk_tree_model_row_changed ()
void | gtk_tree_model_row_inserted ()
void | gtk_tree_model_row_has_child_toggled ()
void | gtk_tree_model_row_deleted ()
void | gtk_tree_model_rows_reordered ()

## Signals

void | row-changed | Run Last
void | row-deleted | Run First
void | row-has-child-toggled | Run Last
void | row-inserted | Run First
void | rows-reordered | Run First

## Types and Values

| GtkTreeModel
struct | GtkTreeIter
| GtkTreePath
| GtkTreeRowReference
struct | GtkTreeModelIface
enum | GtkTreeModelFlags

## Object Hierarchy

        GBoxed
        ├── GtkTreeIter
        ╰── GtkTreePath
        GInterface
        ╰── GtkTreeModel

## Prerequisites

GtkTreeModel requires GObject.

## Known Derived Interfaces

GtkTreeModel is required by GtkTreeSortable.

## Known Implementations

GtkTreeModel is implemented by GtkListStore, GtkTreeModelFilter, GtkTreeModelSort and GtkTreeStore.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkTreeModel interface defines a generic tree interface for use by the GtkTreeView widget. It is an abstract interface, and is designed to be usable with any appropriate data structure. The programmer just has to implement this interface on their own data type for it to be viewable by a GtkTreeView widget.

The model is represented as a hierarchical tree of strongly-typed, columned data. In other words, the model can be seen as a tree where every node has different values depending on which column is being queried. The type of data found in a column is determined by using the GType system (ie. G_TYPE_INT, GTK_TYPE_BUTTON, G_TYPE_POINTER, etc.). The types are homogeneous per column across all nodes. It is important to note that this interface only provides a way of examining a model and observing changes. The implementation of each individual model decides how and if changes are made.

In order to make life simpler for programmers who do not need to write their own specialized model, two generic models are provided — the GtkTreeStore and the GtkListStore. To use these, the developer simply pushes data into these models as necessary. These models provide the data structure as well as all appropriate tree interfaces. As a result, implementing drag and drop, sorting, and storing data is trivial. For the vast majority of trees and lists, these two models are sufficient.

Models are accessed on a node/column level of granularity. One can query for the value of a model at a certain node and a certain column on that node. There are two structures used to reference a particular node in a model. They are the GtkTreePath and the GtkTreeIter [4] Most of the interface consists of operations on a GtkTreeIter.

A path is essentially a potential node. It is a location on a model that may or may not actually correspond to a node on a specific model. The GtkTreePath struct can be converted into either an array of unsigned integers or a string. The string form is a list of numbers separated by a colon. Each number refers to the offset at that level. Thus, the path “0” refers to the root node and the path “2:4” refers to the fifth child of the third node.

By contrast, a GtkTreeIter is a reference to a specific node on a specific model. It is a generic struct with an integer and three generic pointers. These are filled in by the model in a model-specific way. One can convert a path to an iterator by calling `gtk_tree_model_get_iter()`. These iterators are the primary way of accessing a model and are similar to the iterators used by GtkTextBuffer. They are generally statically allocated on the stack and only used for a short time. The model interface defines a set of operations using them for navigating the model.

It is expected that models fill in the iterator with private data. For example, the GtkListStore model, which is internally a simple linked list, stores a list node in one of the pointers. The GtkTreeModelSort stores an array and an offset in two of the pointers. Additionally, there is an integer field. This field is generally filled with a unique stamp per model. This stamp is for catching errors resulting from using invalid iterators with a model.

The lifecycle of an iterator can be a little confusing at first. Iterators are expected to always be valid for as long as the model is unchanged (and doesn't emit a signal). The model is considered to own all outstanding iterators and nothing needs to be done to free them from the user's point of view. Additionally, some models guarantee that an iterator is valid for as long as the node it refers to is valid (most notably the GtkTreeStore and GtkListStore). Although generally uninteresting, as one always has to allow for the case where iterators do not persist beyond a signal, some very important performance enhancements were made in the sort model. As a result, the GTK_TREE_MODEL_ITERS_PERSIST flag was added to indicate this behavior.

To help show some common operation of a model, some examples are provided. The first example shows three ways of getting the iter at the location “3:2:5”. While the first method shown is easier, the second is much more common, as you often get paths from callbacks.

Example 16. Acquiring a GtkTreeIter

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    /* Three ways of getting the iter pointing to the location
     */
    {
      GtkTreePath *path;
      GtkTreeIter iter;
      GtkTreeIter parent_iter;
      /* get the iterator from a string */
      gtk_tree_model_get_iter_from_string (model, &iter, "3:2:5");
      /* get the iterator from a path */
      path = gtk_tree_path_new_from_string ("3:2:5");
      gtk_tree_model_get_iter (model, &iter, path);
      gtk_tree_path_free (path);
      /* walk the tree to find the iterator */
      gtk_tree_model_iter_nth_child (model, &iter, NULL, 3);
      parent_iter = iter;
      gtk_tree_model_iter_nth_child (model, &iter, &parent_iter, 2);
      parent_iter = iter;
      gtk_tree_model_iter_nth_child (model, &iter, &parent_iter, 5);
    }

This second example shows a quick way of iterating through a list and getting a string and an integer from each row. The `populate_model` function used below is not shown, as it is specific to the GtkListStore. For information on how to write such a function, see the GtkListStore documentation.

Example 17. Reading data from a GtkTreeModel

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    enum
    {
      STRING_COLUMN,
      INT_COLUMN,
      N_COLUMNS
    };
    {
      GtkTreeModel *list_store;
      GtkTreeIter iter;
      gboolean valid;
      gint row_count = 0;
      /* make a new list_store */
      list_store = gtk_list_store_new (N_COLUMNS, G_TYPE_STRING, G_TYPE_INT);
      /* Fill the list store with data */
      populate_model (list_store);
      /* Get the first iter in the list */
      valid = gtk_tree_model_get_iter_first (list_store, &iter);
      while (valid)
        {
          /* Walk through the list, reading each row */
          gchar *str_data;
          gint   int_data;
          /* Make sure you terminate calls to gtk_tree_model_get()
           * with a '-1' value
           */
          gtk_tree_model_get (list_store, &iter,
                              STRING_COLUMN, &str_data,
                              INT_COLUMN, &int_data,
                              -1);
          /* Do something with the data */
          g_print ("Row %d: (%s,%d)\n", row_count, str_data, int_data);
          g_free (str_data);
          row_count ++;
          valid = gtk_tree_model_iter_next (list_store, &iter);
        }
    }

## Functions

### GtkTreeModelForeachFunc ()

    gboolean
    (*GtkTreeModelForeachFunc) (GtkTreeModel *model,
                                GtkTreePath *path,
                                GtkTreeIter *iter,
                                gpointer data);

#### Parameters

model | The GtkTreeModel currently being iterated |
path | The current GtkTreePath |
iter | The current GtkTreeIter |
data | The user data passed to `gtk_tree_model_foreach()` |

#### Returns

`TRUE` to stop iterating, `FALSE` to continue.

### gtk_tree_path_new ()

    GtkTreePath *
    gtk_tree_path_new (void);

Creates a new GtkTreePath. This structure refers to a row.

#### Returns

A newly created GtkTreePath.

### gtk_tree_path_new_from_string ()

    GtkTreePath *
    gtk_tree_path_new_from_string (const gchar *path);

Creates a new GtkTreePath initialized to `path` . `path` is expected to be a colon separated list of numbers. For example, the string "10:4:0" would create a path of depth 3 pointing to the 11th child of the root node, the 5th child of that 11th child, and the 1st child of that 5th child. If an invalid path string is passed in, `NULL` is returned.

#### Parameters

path | The string representation of a path. |

#### Returns

A newly-created GtkTreePath, or `NULL`

### gtk_tree_path_new_from_indices ()

    GtkTreePath *
    gtk_tree_path_new_from_indices (gint first_index,
                                    ...);

Creates a new path with `first_index` and `varargs` as indices.

#### Parameters

first_index | first integer |

#### Returns

A newly created GtkTreePath.

Since: 2.2

### gtk_tree_path_to_string ()

    gchar *
    gtk_tree_path_to_string (GtkTreePath *path);

Generates a string representation of the path. This string is a ':' separated list of numbers. For example, "4:10:0:3" would be an acceptable return value for this string.

#### Parameters

path | A GtkTreePath |

#### Returns

A newly-allocated string. Must be freed with `g_free()`.

### gtk_tree_path_new_first ()

    GtkTreePath *
    gtk_tree_path_new_first (void);

Creates a new GtkTreePath. The string representation of this path is "0"

#### Returns

A new GtkTreePath.

### gtk_tree_path_new_root

    #define gtk_tree_path_new_root() gtk_tree_path_new_first()

`gtk_tree_path_new_root` is deprecated and should not be used in newly-written code.

Use `gtk_tree_path_new_first()` instead.

An alternate name for `gtk_tree_path_new_first()` provided for compatibility reasons.

#### Returns

A new GtkTreePath.

### gtk_tree_path_append_index ()

    void
    gtk_tree_path_append_index (GtkTreePath *path,
                                gint index_);

Appends a new index to a path. As a result, the depth of the path is increased.

#### Parameters

path | A GtkTreePath. |
index_ | The index. |

### gtk_tree_path_prepend_index ()

    void
    gtk_tree_path_prepend_index (GtkTreePath *path,
                                 gint index_);

Prepends a new index to a path. As a result, the depth of the path is increased.

#### Parameters

path | A GtkTreePath. |
index_ | The index. |

### gtk_tree_path_get_depth ()

    gint
    gtk_tree_path_get_depth (GtkTreePath *path);

Returns the current depth of `path` .

#### Parameters

path | A GtkTreePath. |

#### Returns

The depth of `path`

### gtk_tree_path_get_indices ()

    gint *
    gtk_tree_path_get_indices (GtkTreePath *path);

Returns the current indices of `path` . This is an array of integers, each representing a node in a tree. This value should not be freed.

#### Parameters

path | A GtkTreePath. |

#### Returns

The current indices, or `NULL`.

### gtk_tree_path_get_indices_with_depth ()

    gint *
    gtk_tree_path_get_indices_with_depth (GtkTreePath *path,
                                          gint *depth);

Returns the current indices of `path` . This is an array of integers, each representing a node in a tree. It also returns the number of elements in the array. The array should not be freed.

#### Parameters

path | A GtkTreePath. |
depth | Number of elements returned in the integer array |

#### Returns

The current indices, or `NULL`.

[array length=depth][transfer none]

Since: 2.22

### gtk_tree_path_free ()

    void
    gtk_tree_path_free (GtkTreePath *path);

Frees `path` .

#### Parameters

path | A GtkTreePath. |

### gtk_tree_path_copy ()

    GtkTreePath *
    gtk_tree_path_copy (const GtkTreePath *path);

Creates a new GtkTreePath as a copy of `path` .

#### Parameters

path | A GtkTreePath. |

#### Returns

A new GtkTreePath.

### gtk_tree_path_compare ()

    gint
    gtk_tree_path_compare (const GtkTreePath *a,
                           const GtkTreePath *b);

Compares two paths. If `a` appears before `b` in a tree, then -1 is returned. If `b` appears before `a` , then 1 is returned. If the two nodes are equal, then 0 is returned.

#### Parameters

a | A GtkTreePath. |
b | A GtkTreePath to compare with. |

#### Returns

The relative positions of `a` and `b`

### gtk_tree_path_next ()

    void
    gtk_tree_path_next (GtkTreePath *path);

Moves the `path` to point to the next node at the current depth.

#### Parameters

path | A GtkTreePath. |

### gtk_tree_path_prev ()

    gboolean
    gtk_tree_path_prev (GtkTreePath *path);

Moves the `path` to point to the previous node at the current depth, if it exists.

#### Parameters

path | A GtkTreePath. |

#### Returns

`TRUE` if `path` has a previous node, and the move was made.

### gtk_tree_path_up ()

    gboolean
    gtk_tree_path_up (GtkTreePath *path);

Moves the `path` to point to its parent node, if it has a parent.

#### Parameters

path | A GtkTreePath. |

#### Returns

`TRUE` if `path` has a parent, and the move was made.

### gtk_tree_path_down ()

    void
    gtk_tree_path_down (GtkTreePath *path);

Moves `path` to point to the first child of the current path.

#### Parameters

path | A GtkTreePath. |

### gtk_tree_path_is_ancestor ()

    gboolean
    gtk_tree_path_is_ancestor (GtkTreePath *path,
                               GtkTreePath *descendant);

Returns `TRUE` if `descendant` is a descendant of `path` .

#### Parameters

path | a GtkTreePath |
descendant | another GtkTreePath |

#### Returns

`TRUE` if `descendant` is contained inside `path`

### gtk_tree_path_is_descendant ()

    gboolean
    gtk_tree_path_is_descendant (GtkTreePath *path,
                                 GtkTreePath *ancestor);

Returns `TRUE` if `path` is a descendant of `ancestor` .

#### Parameters

path | a GtkTreePath |
ancestor | another GtkTreePath |

#### Returns

`TRUE` if `ancestor` contains `path` somewhere below it

### gtk_tree_row_reference_new ()

    GtkTreeRowReference *
    gtk_tree_row_reference_new (GtkTreeModel *model,
                                GtkTreePath *path);

Creates a row reference based on `path` . This reference will keep pointing to the node pointed to by `path` , so long as it exists. It listens to all signals emitted by `model` , and updates its path appropriately. If `path` isn't a valid path in `model` , then `NULL` is returned.

#### Parameters

model | A GtkTreeModel |
path | A valid GtkTreePath to monitor |

#### Returns

A newly allocated GtkTreeRowReference, or `NULL`

### gtk_tree_row_reference_new_proxy ()

    GtkTreeRowReference *
    gtk_tree_row_reference_new_proxy (GObject *proxy,
                                      GtkTreeModel *model,
                                      GtkTreePath *path);

You do not need to use this function. Creates a row reference based on `path` . This reference will keep pointing to the node pointed to by `path` , so long as it exists. If `path` isn't a valid path in `model` , then `NULL` is returned. However, unlike references created with `gtk_tree_row_reference_new()`, it does not listen to the model for changes. The creator of the row reference must do this explicitly using `gtk_tree_row_reference_inserted()`, `gtk_tree_row_reference_deleted()`, `gtk_tree_row_reference_reordered()`.

These functions must be called exactly once per proxy when the corresponding signal on the model is emitted. This single call updates all row references for that proxy. Since built-in GTK+ objects like GtkTreeView already use this mechanism internally, using them as the proxy object will produce unpredictable results. Further more, passing the same object as `model` and `proxy` doesn't work for reasons of internal implementation.

This type of row reference is primarily meant by structures that need to carefully monitor exactly when a row reference updates itself, and is not generally needed by most applications.

#### Parameters

proxy | A proxy GObject |
model | A GtkTreeModel |
path | A valid GtkTreePath to monitor |

#### Returns

A newly allocated GtkTreeRowReference, or `NULL`

### gtk_tree_row_reference_get_model ()

    GtkTreeModel *
    gtk_tree_row_reference_get_model (GtkTreeRowReference *reference);

Returns the model that the row reference is monitoring.

#### Parameters

reference | A GtkTreeRowReference |

#### Returns

the model.

[transfer none]

Since: 2.8

### gtk_tree_row_reference_get_path ()

    GtkTreePath *
    gtk_tree_row_reference_get_path (GtkTreeRowReference *reference);

Returns a path that the row reference currently points to, or `NULL` if the path pointed to is no longer valid.

#### Parameters

reference | A GtkTreeRowReference |

#### Returns

A current path, or `NULL`.

### gtk_tree_row_reference_valid ()

    gboolean
    gtk_tree_row_reference_valid (GtkTreeRowReference *reference);

Returns `TRUE` if the `reference` is non-`NULL` and refers to a current valid path.

#### Parameters

reference | A GtkTreeRowReference, or `NULL`. | [allow-none]

#### Returns

`TRUE` if `reference` points to a valid path.

### gtk_tree_row_reference_free ()

    void
    gtk_tree_row_reference_free (GtkTreeRowReference *reference);

Free's `reference` . `reference` may be `NULL`.

#### Parameters

reference | A GtkTreeRowReference, or `NULL`. | [allow-none]

### gtk_tree_row_reference_copy ()

    GtkTreeRowReference *
    gtk_tree_row_reference_copy (GtkTreeRowReference *reference);

Copies a GtkTreeRowReference.

#### Parameters

reference | a GtkTreeRowReference |

#### Returns

a copy of `reference` .

Since: 2.2

### gtk_tree_row_reference_inserted ()

    void
    gtk_tree_row_reference_inserted (GObject *proxy,
                                     GtkTreePath *path);

Lets a set of row reference created by `gtk_tree_row_reference_new_proxy()` know that the model emitted the "row_inserted" signal.

#### Parameters

proxy | A GObject |
path | The row position that was inserted |

### gtk_tree_row_reference_deleted ()

    void
    gtk_tree_row_reference_deleted (GObject *proxy,
                                    GtkTreePath *path);

Lets a set of row reference created by `gtk_tree_row_reference_new_proxy()` know that the model emitted the "row_deleted" signal.

#### Parameters

proxy | A GObject |
path | The path position that was deleted |

### gtk_tree_row_reference_reordered ()

    void
    gtk_tree_row_reference_reordered (GObject *proxy,
                                      GtkTreePath *path,
                                      GtkTreeIter *iter,
                                      gint *new_order);

Lets a set of row reference created by `gtk_tree_row_reference_new_proxy()` know that the model emitted the "rows_reordered" signal.

#### Parameters

proxy | A GObject |
path | The parent path of the reordered signal |
iter | The iter pointing to the parent of the reordered |
new_order | The new order of rows |

### gtk_tree_iter_copy ()

    GtkTreeIter *
    gtk_tree_iter_copy (GtkTreeIter *iter);

Creates a dynamically allocated tree iterator as a copy of `iter` . This function is not intended for use in applications, because you can just copy the structs by value (`GtkTreeIter new_iter = iter;`). You must free this iter with `gtk_tree_iter_free()`.

#### Parameters

iter | A GtkTreeIter. |

#### Returns

a newly-allocated copy of `iter` .

### gtk_tree_iter_free ()

    void
    gtk_tree_iter_free (GtkTreeIter *iter);

Frees an iterator that has been allocated by `gtk_tree_iter_copy()`. This function is mainly used for language bindings.

#### Parameters

iter | A dynamically allocated tree iterator. |

### gtk_tree_model_get_flags ()

    GtkTreeModelFlags
    gtk_tree_model_get_flags (GtkTreeModel *tree_model);

Returns a set of flags supported by this interface. The flags are a bitwise combination of GtkTreeModelFlags. The flags supported should not change during the lifecycle of the `tree_model` .

#### Parameters

tree_model | A GtkTreeModel. |

#### Returns

The flags supported by this interface.

### gtk_tree_model_get_n_columns ()

    gint
    gtk_tree_model_get_n_columns (GtkTreeModel *tree_model);

Returns the number of columns supported by `tree_model` .

#### Parameters

tree_model | A GtkTreeModel. |

#### Returns

The number of columns.

### gtk_tree_model_get_column_type ()

    GType
    gtk_tree_model_get_column_type (GtkTreeModel *tree_model,
                                    gint index_);

Returns the type of the column.

#### Parameters

tree_model | A GtkTreeModel. |
index_ | The column index. |

#### Returns

The type of the column.

[transfer none]

### gtk_tree_model_get_iter ()

    gboolean
    gtk_tree_model_get_iter (GtkTreeModel *tree_model,
                             GtkTreeIter *iter,
                             GtkTreePath *path);

Sets `iter` to a valid iterator pointing to `path` .

#### Parameters

tree_model | A GtkTreeModel. |
iter | The uninitialized GtkTreeIter. | [out]
path | The GtkTreePath. |

#### Returns

`TRUE`, if `iter` was set.

### gtk_tree_model_get_iter_from_string ()

    gboolean
    gtk_tree_model_get_iter_from_string (GtkTreeModel *tree_model,
                                         GtkTreeIter *iter,
                                         const gchar *path_string);

Sets `iter` to a valid iterator pointing to `path_string` , if it exists. Otherwise, `iter` is left invalid and `FALSE` is returned.

#### Parameters

tree_model | A GtkTreeModel. |
iter | An uninitialized GtkTreeIter. | [out]
path_string | A string representation of a GtkTreePath. |

#### Returns

`TRUE`, if `iter` was set.

### gtk_tree_model_get_iter_first ()

    gboolean
    gtk_tree_model_get_iter_first (GtkTreeModel *tree_model,
                                   GtkTreeIter *iter);

Initializes `iter` with the first iterator in the tree (the one at the path "0") and returns `TRUE`. Returns `FALSE` if the tree is empty.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The uninitialized GtkTreeIter. | [out]

#### Returns

`TRUE`, if `iter` was set.

### gtk_tree_model_get_iter_root()

    #define gtk_tree_model_get_iter_root(tree_model, iter) gtk_tree_model_get_iter_first(tree_model, iter)

`gtk_tree_model_get_iter_root` is deprecated and should not be used in newly-written code.

A alternate name for `gtk_tree_model_get_iter_first()` provided for compatibility reasons; this macro will be deprecated in future versions of GTK+.

#### Parameters

tree_model | A GtkTreeModel. |
iter | uninitialized GtkTreeIter. |

#### Returns

`TRUE`, if `iter` was set.

### gtk_tree_model_get_path ()

    GtkTreePath *
    gtk_tree_model_get_path (GtkTreeModel *tree_model,
                             GtkTreeIter *iter);

Returns a newly-created GtkTreePath referenced by `iter` . This path should be freed with `gtk_tree_path_free()`.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter. |

#### Returns

a newly-created GtkTreePath.

### gtk_tree_model_get_value ()

    void
    gtk_tree_model_get_value (GtkTreeModel *tree_model,
                              GtkTreeIter *iter,
                              gint column,
                              GValue *value);

Initializes and sets `value` to that at `column` . When done with `value` , `g_value_unset()` needs to be called to free any allocated memory.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter. |
column | The column to lookup the value at. |
value | An empty GValue to set. | [out][transfer none]

### gtk_tree_model_iter_next ()

    gboolean
    gtk_tree_model_iter_next (GtkTreeModel *tree_model,
                              GtkTreeIter *iter);

Sets `iter` to point to the node following it at the current level. If there is no next `iter` , `FALSE` is returned and `iter` is set to be invalid.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter. | [in]

#### Returns

`TRUE` if `iter` has been changed to the next node.

### gtk_tree_model_iter_children ()

    gboolean
    gtk_tree_model_iter_children (GtkTreeModel *tree_model,
                                  GtkTreeIter *iter,
                                  GtkTreeIter *parent);

Sets `iter` to point to the first child of `parent` . If `parent` has no children, `FALSE` is returned and `iter` is set to be invalid. `parent` will remain a valid node after this function has been called.

If `parent` is `NULL` returns the first node, equivalent to `gtk_tree_model_get_iter_first (tree_model, iter);`

#### Parameters

tree_model | A GtkTreeModel. |
iter | The new GtkTreeIter to be set to the child. | [out]
parent | The GtkTreeIter, or `NULL`. | [allow-none]

#### Returns

`TRUE`, if `child` has been set to the first child.

### gtk_tree_model_iter_has_child ()

    gboolean
    gtk_tree_model_iter_has_child (GtkTreeModel *tree_model,
                                   GtkTreeIter *iter);

Returns `TRUE` if `iter` has children, `FALSE` otherwise.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter to test for children. |

#### Returns

`TRUE` if `iter` has children.

### gtk_tree_model_iter_n_children ()

    gint
    gtk_tree_model_iter_n_children (GtkTreeModel *tree_model,
                                    GtkTreeIter *iter);

Returns the number of children that `iter` has. As a special case, if `iter` is `NULL`, then the number of toplevel nodes is returned.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter, or `NULL`. | [allow-none]

#### Returns

The number of children of `iter` .

### gtk_tree_model_iter_nth_child ()

    gboolean
    gtk_tree_model_iter_nth_child (GtkTreeModel *tree_model,
                                   GtkTreeIter *iter,
                                   GtkTreeIter *parent,
                                   gint n);

Sets `iter` to be the child of `parent` , using the given index. The first index is 0. If `n` is too big, or `parent` has no children, `iter` is set to an invalid iterator and `FALSE` is returned. `parent` will remain a valid node after this function has been called. As a special case, if `parent` is `NULL`, then the `n` th root node is set.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter to set to the nth child. | [out]
parent | The GtkTreeIter to get the child from, or `NULL`. | [allow-none]
n | Then index of the desired child. |

#### Returns

`TRUE`, if `parent` has an `n` th child.

### gtk_tree_model_iter_parent ()

    gboolean
    gtk_tree_model_iter_parent (GtkTreeModel *tree_model,
                                GtkTreeIter *iter,
                                GtkTreeIter *child);

Sets `iter` to be the parent of `child` . If `child` is at the toplevel, and doesn't have a parent, then `iter` is set to an invalid iterator and `FALSE` is returned. `child` will remain a valid node after this function has been called.

#### Parameters

tree_model | A GtkTreeModel |
iter | The new GtkTreeIter to set to the parent. | [out]
child | The GtkTreeIter. |

#### Returns

`TRUE`, if `iter` is set to the parent of `child` .

### gtk_tree_model_get_string_from_iter ()

    gchar *
    gtk_tree_model_get_string_from_iter (GtkTreeModel *tree_model,
                                         GtkTreeIter *iter);

Generates a string representation of the iter. This string is a ':' separated list of numbers. For example, "4:10:0:3" would be an acceptable return value for this string.

#### Parameters

tree_model | A GtkTreeModel. |
iter | An GtkTreeIter. |

#### Returns

A newly-allocated string. Must be freed with `g_free()`.

Since: 2.2

### gtk_tree_model_ref_node ()

    void
    gtk_tree_model_ref_node (GtkTreeModel *tree_model,
                             GtkTreeIter *iter);

Lets the tree ref the node. This is an optional method for models to implement. To be more specific, models may ignore this call as it exists primarily for performance reasons.

This function is primarily meant as a way for views to let caching model know when nodes are being displayed (and hence, whether or not to cache that node.) For example, a file-system based model would not want to keep the entire file-hierarchy in memory, just the sections that are currently being displayed by every current view.

A model should be expected to be able to get an iter independent of its reffed state.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter. |

### gtk_tree_model_unref_node ()

    void
    gtk_tree_model_unref_node (GtkTreeModel *tree_model,
                               GtkTreeIter *iter);

Lets the tree unref the node. This is an optional method for models to implement. To be more specific, models may ignore this call as it exists primarily for performance reasons.

For more information on what this means, see `gtk_tree_model_ref_node()`. Please note that nodes that are deleted are not unreffed.

#### Parameters

tree_model | A GtkTreeModel. |
iter | The GtkTreeIter. |

### gtk_tree_model_get ()

    void
    gtk_tree_model_get (GtkTreeModel *tree_model,
                        GtkTreeIter *iter,
                        ...);

Gets the value of one or more cells in the row referenced by `iter` . The variable argument list should contain integer column numbers, each column number followed by a place to store the value being retrieved. The list is terminated by a -1. For example, to get a value from column 0 with type `G_TYPE_STRING`, you would write: `gtk_tree_model_get (model, iter, 0, &place_string_here, -1)`, where `place_string_here` is a gchar* to be filled with the string.

Returned values with type `G_TYPE_OBJECT` have to be unreferenced, values with type `G_TYPE_STRING` or `G_TYPE_BOXED` have to be freed. Other values are passed by value.

#### Parameters

tree_model | a GtkTreeModel |
iter | a row in `tree_model` |

### gtk_tree_model_get_valist ()

    void
    gtk_tree_model_get_valist (GtkTreeModel *tree_model,
                               GtkTreeIter *iter,
                               va_list var_args);

See `gtk_tree_model_get()`, this version takes a va_list for language bindings to use.

#### Parameters

tree_model | a GtkTreeModel |
iter | a row in `tree_model` |
var_args | va_list of column/return location pairs |

### gtk_tree_model_foreach ()

    void
    gtk_tree_model_foreach (GtkTreeModel *model,
                            GtkTreeModelForeachFunc func,
                            gpointer user_data);

Calls func on each node in model in a depth-first fashion. If `func` returns `TRUE`, then the tree ceases to be walked, and `gtk_tree_model_foreach()` returns.

#### Parameters

model | A GtkTreeModel |
func | A function to be called on each row. | [scope call]
user_data | User data to passed to func. |

### gtk_tree_model_row_changed ()

    void
    gtk_tree_model_row_changed (GtkTreeModel *tree_model,
                                GtkTreePath *path,
                                GtkTreeIter *iter);

`gtk_tree_model_row_changed` is deprecated and should not be used in newly-written code.

Emits the "row-changed" signal on `tree_model` .

#### Parameters

tree_model | A GtkTreeModel |
path | A GtkTreePath pointing to the changed row |
iter | A valid GtkTreeIter pointing to the changed row |

### gtk_tree_model_row_inserted ()

    void
    gtk_tree_model_row_inserted (GtkTreeModel *tree_model,
                                 GtkTreePath *path,
                                 GtkTreeIter *iter);

Emits the "row-inserted" signal on `tree_model`

#### Parameters

tree_model | A GtkTreeModel |
path | A GtkTreePath pointing to the inserted row |
iter | A valid GtkTreeIter pointing to the inserted row |

### gtk_tree_model_row_has_child_toggled ()

    void
    gtk_tree_model_row_has_child_toggled (GtkTreeModel *tree_model,
                                          GtkTreePath *path,
                                          GtkTreeIter *iter);

Emits the "row-has-child-toggled" signal on `tree_model` . This should be called by models after the child state of a node changes.

#### Parameters

tree_model | A GtkTreeModel |
path | A GtkTreePath pointing to the changed row |
iter | A valid GtkTreeIter pointing to the changed row |

### gtk_tree_model_row_deleted ()

    void
    gtk_tree_model_row_deleted (GtkTreeModel *tree_model,
                                GtkTreePath *path);

Emits the "row-deleted" signal on `tree_model` . This should be called by models after a row has been removed. The location pointed to by `path` should be the location that the row previously was at. It may not be a valid location anymore.

#### Parameters

tree_model | A GtkTreeModel |
path | A GtkTreePath pointing to the previous location of the deleted row. |

### gtk_tree_model_rows_reordered ()

    void
    gtk_tree_model_rows_reordered (GtkTreeModel *tree_model,
                                   GtkTreePath *path,
                                   GtkTreeIter *iter,
                                   gint *new_order);

Emits the "rows-reordered" signal on `tree_model` . This should be called by models when their rows have been reordered.

#### Parameters

tree_model | A GtkTreeModel |
path | A GtkTreePath pointing to the tree node whose children have been reordered |
iter | A valid GtkTreeIter pointing to the node whose children have been reordered, or `NULL` if the depth of `path` is 0. |
new_order | an array of integers mapping the current position of each child to its old position before the re-ordering, i.e. `new_order` `[newpos] = oldpos`. |

## Types and Values

### GtkTreeModel

    typedef struct _GtkTreeModel GtkTreeModel;

### struct GtkTreeIter

    struct GtkTreeIter {
      gint stamp;
      gpointer user_data;
      gpointer user_data2;
      gpointer user_data3;
    };

The GtkTreeIter is the primary structure for accessing a structure. Models are expected to put a unique integer in the `stamp` member, and put model-specific data in the three `user_data` members.

### GtkTreePath

    typedef struct _GtkTreePath GtkTreePath;

### GtkTreeRowReference

    typedef struct _GtkTreeRowReference GtkTreeRowReference;

### struct GtkTreeModelIface

    struct GtkTreeModelIface {
      GTypeInterface g_iface;

      /* Signals */
      void         (* row_changed)           (GtkTreeModel *tree_model,
    					  GtkTreePath  *path,
    					  GtkTreeIter  *iter);
      void         (* row_inserted)          (GtkTreeModel *tree_model,
    					  GtkTreePath  *path,
    					  GtkTreeIter  *iter);
      void         (* row_has_child_toggled) (GtkTreeModel *tree_model,
    					  GtkTreePath  *path,
    					  GtkTreeIter  *iter);
      void         (* row_deleted)           (GtkTreeModel *tree_model,
    					  GtkTreePath  *path);
      void         (* rows_reordered)        (GtkTreeModel *tree_model,
    					  GtkTreePath  *path,
    					  GtkTreeIter  *iter,
    					  gint         *new_order);

      /* Virtual Table */
      GtkTreeModelFlags (* get_flags)  (GtkTreeModel *tree_model);

      gint         (* get_n_columns)   (GtkTreeModel *tree_model);
      GType        (* get_column_type) (GtkTreeModel *tree_model,
    				    gint          index_);
      gboolean     (* get_iter)        (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter,
    				    GtkTreePath  *path);
      GtkTreePath *(* get_path)        (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter);
      void         (* get_value)       (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter,
    				    gint          column,
    				    GValue       *value);
      gboolean     (* iter_next)       (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter);
      gboolean     (* iter_children)   (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter,
    				    GtkTreeIter  *parent);
      gboolean     (* iter_has_child)  (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter);
      gint         (* iter_n_children) (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter);
      gboolean     (* iter_nth_child)  (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter,
    				    GtkTreeIter  *parent,
    				    gint          n);
      gboolean     (* iter_parent)     (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter,
    				    GtkTreeIter  *child);
      void         (* ref_node)        (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter);
      void         (* unref_node)      (GtkTreeModel *tree_model,
    				    GtkTreeIter  *iter);
    };

### enum GtkTreeModelFlags

These flags indicate various properties of a GtkTreeModel. They are returned by `gtk_tree_model_get_flags()`, and must be static for the lifetime of the object. A more complete description of GTK_TREE_MODEL_ITERS_PERSIST can be found in the overview of this section.

#### Members

GTK_TREE_MODEL_ITERS_PERSIST | Iterators survive all signals emitted by the tree. |
GTK_TREE_MODEL_LIST_ONLY | The model is a list only, and never has children |

## Signal Details

### The `“row-changed”` signal

    void
    user_function (GtkTreeModel *tree_model,
                   GtkTreePath  *path,
                   GtkTreeIter  *iter,
                   gpointer      user_data)

This signal is emitted when a row in the model has changed.

#### Parameters

tree_model | the GtkTreeModel on which the signal is emitted |
path | a GtkTreePath identifying the changed row |
iter | a valid GtkTreeIter pointing to the changed row |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“row-deleted”` signal

    void
    user_function (GtkTreeModel *tree_model,
                   GtkTreePath  *path,
                   gpointer      user_data)

This signal is emitted when a row has been deleted.

Note that no iterator is passed to the signal handler, since the row is already deleted.

This should be called by models after a row has been removed. The location pointed to by `path` should be the location that the row previously was at. It may not be a valid location anymore.

#### Parameters

tree_model | the GtkTreeModel on which the signal is emitted |
path | a GtkTreePath identifying the row |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“row-has-child-toggled”` signal

    void
    user_function (GtkTreeModel *tree_model,
                   GtkTreePath  *path,
                   GtkTreeIter  *iter,
                   gpointer      user_data)

This signal is emitted when a row has gotten the first child row or lost its last child row.

#### Parameters

tree_model | the GtkTreeModel on which the signal is emitted |
path | a GtkTreePath identifying the row |
iter | a valid GtkTreeIter pointing to the row |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“row-inserted”` signal

    void
    user_function (GtkTreeModel *tree_model,
                   GtkTreePath  *path,
                   GtkTreeIter  *iter,
                   gpointer      user_data)

This signal is emitted when a new row has been inserted in the model.

Note that the row may still be empty at this point, since it is a common pattern to first insert an empty row, and then fill it with the desired values.

#### Parameters

tree_model | the GtkTreeModel on which the signal is emitted |
path | a GtkTreePath identifying the new row |
iter | a valid GtkTreeIter pointing to the new row |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“rows-reordered”` signal

    void
    user_function (GtkTreeModel *tree_model,
                   GtkTreePath  *path,
                   GtkTreeIter  *iter,
                   gpointer      new_order,
                   gpointer      user_data)

This signal is emitted when the children of a node in the GtkTreeModel have been reordered.

Note that this signal is not emitted when rows are reordered by DND, since this is implemented by removing and then reinserting the row.

#### Parameters

tree_model | the GtkTreeModel on which the signal is emitted |
path | a GtkTreePath identifying the tree node whose children have been reordered |
iter | a valid GtkTreeIter pointing to the node whose |
new_order | an array of integers mapping the current position of each child to its old position before the re-ordering, i.e. `new_order` `[newpos] = oldpos`. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

## See Also

GtkTreeView, GtkTreeStore, GtkListStore, GtkTreeDnd, GtkTreeSortable

[4] Here, iter is short for “iterator”